<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item prop="title">
                <el-input v-model="queryParams.title" placeholder="请输入账单标题" clearable @keyup.enter.native="handleQuery" />
            </el-form-item>
            <el-form-item>
                <el-date-picker v-model="monthTime" value-format="yyyy-MM" type="month" placeholder="选择月"> </el-date-picker>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
                <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" fit highlight-current-row border stripe :data="billList" @selection-change="handleSelectionChange">
            <!--      <el-table-column type="selection" width="55" align="center" fixed="left"/>-->
            <el-table-column label="编号" align="center" prop="id" width="100px" />
            <el-table-column label="标题" align="center" prop="title" />
            <el-table-column label="开始时间" align="center" prop="beginTime" />
            <el-table-column label="结束时间" align="center" prop="endTime" />
            <el-table-column label="提交人" align="center" prop="createBy" />
            <el-table-column label="门店数量" align="center" prop="storeNum" />
            <el-table-column label="原材料备用金（元）" align="center" prop="materialImprestAmount" width="170" />
            <el-table-column label="系统维护费（元）" align="center" prop="systemMaintenanceAmount" width="150" />
            <el-table-column label="洗衣费（元）" align="center" prop="washClothAmount" />
            <el-table-column label="结算（元）" align="center" prop="settlementAmount" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="150">
                <template slot-scope="scope">
                    <el-button type="text" icon="el-icon-edit" @click="storeDetail(scope.row)">门店结算详情</el-button>
                    <el-button type="text" icon="el-icon-edit" @click="factoryDetail(scope.row)" v-hasPermi="['settlement:bill:query']">工厂结算详情</el-button>
                </template>
            </el-table-column>
        </el-table>

        <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />

        <!-- 添加或修改结算费率对话框 -->
        <el-dialog :title="title" :visible.sync="open" size="30%" append-to-body>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules" label-width="100px">
                    <el-col :span="24">
                        <el-form-item label="选择月份" required>
                            <el-date-picker v-model="form.month" value-format="yyyy-MM" type="month" placeholder="选择月"> </el-date-picker>
                        </el-form-item>
                        <el-form-item label="账单标题" prop="title">
                            <el-input v-model="form.title" />
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listRate, getRate, delRate, addRate, updateRate, updateRateStatus } from '@/api/settlement/rate'
import { allOrg } from '@/api/system/store'
import { insertSettlementBill, listSettlementBill } from '@/api/settlement/bill'

export default {
    name: 'bill',
    data() {
        return {
            monthTime: '',
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 结算费率表格数据
            billList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {
                pageNum: 1,
                pageSize: 10,
                title: null
            },
            // 表单参数
            form: {},
            // 表单校验
            rules: {
                title: [{ required: true, message: '账单标题不能为空', trigger: 'blur' }]
            },
            sourceType: null
        }
    },
    created() {
        this.getList()
    },
    methods: {
        /** 查询结算费率列表 */
        getList() {
            this.loading = true
            this.queryParams.monthTime = this.monthTime
            listSettlementBill(this.queryParams).then((response) => {
                this.billList = response.data.records
                this.total = response.data.total
                this.loading = false
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                sourceType: null,
                orgId: null,
                factoryRate: null,
                materialRate: null,
                manageRate: null,
                depositRate: null,
                otherStoreRate: null,
                payRate: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.monthTime = null
            this.queryParams.monthTime = null
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加结算费率'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getRate(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '修改结算费率'
            })
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    insertSettlementBill(this.form).then((response) => {
                        this.$modal.msgSuccess('新增成功')
                        this.open = false
                        this.getList()
                    })
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除结算费率编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delRate(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/settlement/rate/export',
                {
                    ...this.queryParams
                },
                `rate_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        },
        factoryDetail(row) {
            this.$tab.openPage(row.title + '的工厂结算详情', '/settlement/factory/' + row.id)
        },
        storeDetail(row) {
            this.$tab.openPage(row.title + '的门店结算详情', '/settlement/store/' + row.id)
        }
    }
}
</script>
